pcl::tracking::NearestPairPointCloudCoherence< PointInT > Class Template Reference

NearestPairPointCloudCoherence computes coherence between two pointclouds using the nearest point pairs. More...

`#include <pcl/tracking/nearest_pair_point_cloud_coherence.h>`

Inheritance diagram for pcl::tracking::NearestPairPointCloudCoherence< PointInT >:

## Public Types

typedef PointCloudCoherence< PointInT >::PointCoherencePtr | PointCoherencePtr
typedef PointCloudCoherence< PointInT >::PointCloudInConstPtr | PointCloudInConstPtr
typedef PointCloudCoherence< PointInT > | BaseClass
typedef boost::shared_ptr< NearestPairPointCloudCoherence< PointInT > > | Ptr
typedef boost::shared_ptr< const NearestPairPointCloudCoherence< PointInT > > | ConstPtr
typedef boost::shared_ptr< pcl::search::Search< PointInT > > | SearchPtr
typedef boost::shared_ptr< const pcl::search::Search< PointInT > > | SearchConstPtr
Public Types inherited from pcl::tracking::PointCloudCoherence< PointInT >
typedef boost::shared_ptr< PointCloudCoherence< PointInT > > | Ptr
typedef boost::shared_ptr< const PointCloudCoherence< PointInT > > | ConstPtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef PointCoherence< PointInT >::Ptr | PointCoherencePtr

## Public Member Functions

| NearestPairPointCloudCoherence ()
| empty constructor More...
void | setSearchMethod (const SearchPtr &search)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
SearchPtr | getSearchMethod ()
| Get a pointer to the point cloud dataset. More...
virtual void | setTargetCloud (const PointCloudInConstPtr &cloud)
| add a PointCoherence to the PointCloudCoherence. More...
void | setMaximumDistance (double val)
| set maximum distance to be taken into account. More...
Public Member Functions inherited from pcl::tracking::PointCloudCoherence< PointInT >
| PointCloudCoherence ()
| Constructor. More...
virtual | ~PointCloudCoherence ()
| Destructor. More...
void | compute (const PointCloudInConstPtr &cloud, const IndicesConstPtr &indices, float &w_i)
| compute coherence between two pointclouds. More...
std::vector< PointCoherencePtr > | getPointCoherences ()
| get a list of pcl::tracking::PointCoherence. More...
void | setPointCoherences (std::vector< PointCoherencePtr > coherences)
| set a list of pcl::tracking::PointCoherence. More...
void | addPointCoherence (PointCoherencePtr coherence)
| add a PointCoherence to the PointCloudCoherence. More...

## Protected Member Functions

virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual void | computeCoherence (const PointCloudInConstPtr &cloud, const IndicesConstPtr &indices, float &w_j)
| compute the nearest pairs and compute coherence using point_coherences_ More...
Protected Member Functions inherited from pcl::tracking::PointCloudCoherence< PointInT >
double | calcPointCoherence (PointInT &source, PointInT &target)
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...

## Protected Attributes

bool | new_target_
| A flag which is true if target_input_ is updated. More...
SearchPtr | search_
| A pointer to the spatial search object. More...
double | maximum_distance_
| max of distance for points to be taken into account More...
Protected Attributes inherited from pcl::tracking::PointCloudCoherence< PointInT >
std::string | coherence_name_
| The coherence name. More...
PointCloudInConstPtr | target_input_
| a pointer to target point cloud More...
std::vector< PointCoherencePtr > | point_coherences_
| a list of pointers to PointCoherence. More...

## Detailed Description

### template<typename PointInT>
class pcl::tracking::NearestPairPointCloudCoherence< PointInT >

NearestPairPointCloudCoherence computes coherence between two pointclouds using the nearest point pairs.

Author
  Ryohei Ueda

Definition at line 18 of file nearest_pair_point_cloud_coherence.h.

## Member Typedef Documentation

template<typename PointInT>

typedef PointCloudCoherence<PointInT> pcl::tracking::NearestPairPointCloudCoherence< PointInT >::BaseClass

Definition at line 27 of file nearest_pair_point_cloud_coherence.h.

template<typename PointInT>

typedef boost::shared_ptr<const NearestPairPointCloudCoherence<PointInT> > pcl::tracking::NearestPairPointCloudCoherence< PointInT >::ConstPtr

Definition at line 30 of file nearest_pair_point_cloud_coherence.h.

template<typename PointInT>

typedef PointCloudCoherence<PointInT>::PointCloudInConstPtr pcl::tracking::NearestPairPointCloudCoherence< PointInT >::PointCloudInConstPtr

Definition at line 26 of file nearest_pair_point_cloud_coherence.h.

template<typename PointInT>

typedef PointCloudCoherence<PointInT>::PointCoherencePtr pcl::tracking::NearestPairPointCloudCoherence< PointInT >::PointCoherencePtr

Definition at line 25 of file nearest_pair_point_cloud_coherence.h.

template<typename PointInT>

typedef boost::shared_ptr<NearestPairPointCloudCoherence<PointInT> > pcl::tracking::NearestPairPointCloudCoherence< PointInT >::Ptr

Definition at line 29 of file nearest_pair_point_cloud_coherence.h.

template<typename PointInT>

typedef boost::shared_ptr<const pcl::search::Search<PointInT> > pcl::tracking::NearestPairPointCloudCoherence< PointInT >::SearchConstPtr

Definition at line 32 of file nearest_pair_point_cloud_coherence.h.

template<typename PointInT>

typedef boost::shared_ptr<pcl::search::Search<PointInT> > pcl::tracking::NearestPairPointCloudCoherence< PointInT >::SearchPtr

Definition at line 31 of file nearest_pair_point_cloud_coherence.h.

## Constructor & Destructor Documentation

template<typename PointInT>

pcl::tracking::NearestPairPointCloudCoherence< PointInT >::NearestPairPointCloudCoherence | ( |  | ) |

inline

empty constructor

Definition at line 35 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::PointCloudCoherence< PointInT >::coherence_name_.

## Member Function Documentation

template<typename PointInT >

void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::computeCoherence | ( | const PointCloudInConstPtr & | cloud,
|  | const IndicesConstPtr & | indices,
|  | float & | w_j
| ) |  |

protected virtual

compute the nearest pairs and compute coherence using point_coherences_

Implements pcl::tracking::PointCloudCoherence< PointInT >.

Reimplemented in pcl::tracking::ApproxNearestPairPointCloudCoherence< PointInT >.

Definition at line 13 of file nearest_pair_point_cloud_coherence.hpp.

template<typename PointInT>

SearchPtr pcl::tracking::NearestPairPointCloudCoherence< PointInT >::getSearchMethod | ( |  | ) |

inline

Get a pointer to the point cloud dataset.

Definition at line 55 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::search_.

template<typename PointInT >

bool pcl::tracking::NearestPairPointCloudCoherence< PointInT >::initCompute | ( |  | ) |

protected virtual

This method should get called before starting the actual computation.

Reimplemented from pcl::tracking::PointCloudCoherence< PointInT >.

Reimplemented in pcl::tracking::ApproxNearestPairPointCloudCoherence< PointInT >.

Definition at line 45 of file nearest_pair_point_cloud_coherence.hpp.

Referenced by pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setMaximumDistance().

template<typename PointInT>

void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setMaximumDistance | ( | double | val | ) |

inline

set maximum distance to be taken into account.

Parameters

  [in] | val | maximum distance.

Definition at line 70 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::initCompute(), and pcl::tracking::NearestPairPointCloudCoherence< PointInT >::maximum_distance_.

template<typename PointInT>

void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setSearchMethod | ( | const SearchPtr & | search | ) |

inline

Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.

This is optional, if this is not set, it will only use the data in the input cloud to estimate the features. This is useful when you only need to compute the features for a downsampled cloud.

Parameters

  search | a pointer to a PointCloud message

Definition at line 51 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::search_.

template<typename PointInT>

virtual void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setTargetCloud | ( | const PointCloudInConstPtr & | cloud | ) |

inline virtual

add a PointCoherence to the PointCloudCoherence.

Parameters

  [in] | cloud | coherence a pointer to PointCoherence.

Reimplemented from pcl::tracking::PointCloudCoherence< PointInT >.

Definition at line 61 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::new_target_, and pcl::tracking::PointCloudCoherence< PointInT >::setTargetCloud().

## Member Data Documentation

template<typename PointInT>

double pcl::tracking::NearestPairPointCloudCoherence< PointInT >::maximum_distance_

protected

max of distance for points to be taken into account

Definition at line 85 of file nearest_pair_point_cloud_coherence.h.

Referenced by pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setMaximumDistance().

template<typename PointInT>

bool pcl::tracking::NearestPairPointCloudCoherence< PointInT >::new_target_

protected

A flag which is true if target_input_ is updated.

Definition at line 79 of file nearest_pair_point_cloud_coherence.h.

Referenced by pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setTargetCloud().

template<typename PointInT>

SearchPtr pcl::tracking::NearestPairPointCloudCoherence< PointInT >::search_

protected

A pointer to the spatial search object.

Definition at line 82 of file nearest_pair_point_cloud_coherence.h.

Referenced by pcl::tracking::NearestPairPointCloudCoherence< PointInT >::getSearchMethod(), and pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setSearchMethod().

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/tracking/include/pcl/tracking/nearest_pair_point_cloud_coherence.h
- /build/pcl-6_P28C/pcl-1.7.2/tracking/include/pcl/tracking/impl/nearest_pair_point_cloud_coherence.hpp